IncludeFile "HTTPGetFromWeb2.pb"

;******************************************************************************
; HTTPGetFromWeb() - Test
; November 7, 2007 by Luis
;******************************************************************************

Global tHTTP.T_PBL_HTTP_GET_FROM_WEB
Global sTemp1.STRING, sTemp2.STRING
Global lRetVal.l


Procedure MyCallStart (*tHTTP.T_PBL_HTTP_GET_FROM_WEB, hRequest.l)
 Protected sText.s, lCount.l
 Protected sBuffer.s = Space(1024), lStringBufferSize.l = 1024
  
 sText = "-> MyCallStart() called ... this means the download is about to start." 
 Debug sText
 Debug ""
 
 sText = "You can access all params stored in *tHTTP here."
 Debug sText
 
 sText = "And you can access the handle of the HTTP request to call HttpQueryInfo()."
 Debug sText
 Debug ""
 
 ; *** Query various infos ***     
 
 Debug "#HTTP_QUERY_RAW_HEADERS_CRLF = "

 If (HttpQueryInfo_(hRequest, #HTTP_QUERY_RAW_HEADERS_CRLF, @sBuffer, @lStringBufferSize, #Null))
    Repeat 
        lCount + 1
        sText = StringField(sBuffer, lCount, #CR$)        
        If Left(sText, 1) = #LF$        
            sText = Right(sText, Len(sText) - 1)
        EndIf            
        Debug sText 
        If Len(sText) = 0: Break: EndIf
    ForEver    
 EndIf
 
 If (HttpQueryInfo_(hRequest, #HTTP_QUERY_CONTENT_TYPE, @sBuffer, @lStringBufferSize, #Null))
    Debug "HTTP_QUERY_CONTENT_TYPE = " + sBuffer    
 EndIf
 
 If (HttpQueryInfo_(hRequest, #HTTP_QUERY_CONTENT_LENGTH , @sBuffer, @lStringBufferSize, #Null))
    Debug "HTTP_QUERY_CONTENT_LENGTH = " + sBuffer    
 EndIf

 If (HttpQueryInfo_(hRequest, #HTTP_QUERY_STATUS_CODE, @sBuffer, @lStringBufferSize, #Null))
    Debug "HTTP_QUERY_STATUS_CODE = " + sBuffer    
 EndIf
 
  If (HttpQueryInfo_(hRequest, #HTTP_QUERY_STATUS_TEXT, @sBuffer, @lStringBufferSize, #Null))
    Debug "HTTP_QUERY_STATUS_TEXT = " + sBuffer    
 EndIf

 Debug ""
 sText = "-> MyCallStart() ends here"
 Debug sText
 Debug ""
  
EndProcedure


Procedure MyCallEnd (*tHTTP.T_PBL_HTTP_GET_FROM_WEB, lRetVal, lBytesReceived.l, lSize.l, lElapsedTime.l)
 Protected sText.s
 
 sText = "-> MyCallEnd (ErrCode = " + Str(lRetVal) + ", Bytes = " + Str(lBytesReceived) + ", Size = " + Str(lSize) + ", Elapsed = " + Str(lElapsedTime) + ")" 
 
 Debug ""
 Debug sText
EndProcedure

 
Procedure.l MyCallBack (*tHTTP.T_PBL_HTTP_GET_FROM_WEB, lBytesReceived.l, lSize.l, lElapsedTime.l)
 Protected sText.s
 
 sText = "-> MyCallBack (Bytes = " + Str(lBytesReceived) + ", Size = " + Str(lSize) + ", Elapsed = " + Str(lElapsedTime) + ")" 
 
 If (lElapsedTime > 0)
    sText + " - Speed = " + Str (lBytesReceived / lElapsedTime / 1024) + " KB/sec"
 EndIf
 
 Debug sText
 
 ProcedureReturn #True ; return #False to abort download
EndProcedure
 
 

; error 404 example
;
; tHTTP\sURL = "http://www.somedomain.com//foo/bar.zip"  
 
 
; content length unknown and automatic redirection enabled example

; tHTTP\sURL = "http://finance.yahoo.com/d/quotes.csv?s=MVC+MIDD+BWLD+LOOP&f=sl1d1t1" ; by the way, good stocks to own :-)
; try to disable redirection with
; tHTTP\lFlags = #INTERNET_FLAG_NO_UI | #INTERNET_FLAG_RELOAD | #INTERNET_FLAG_NO_AUTO_REDIRECT
 
 
tHTTP\sURL = "http://www.purebasic.com/download/PureBasic_Demo.exe" 

tHTTP\lThreadID = 0
tHTTP\lDestination = #PBL_WRITE_TO_FILE
tHTTP\lChunkSize = 512*1024 ; 512 KB
tHTTP\fpCallstart = @MyCallStart()
tHTTP\fpCallBack = @MyCallBack()
tHTTP\fpCallEnd = @MyCallEnd()
tHTTP\sFullFileName = "c:\PureBasic_Demo.exe"

URLGetDomain (tHTTP\sURL, @sTemp1)
Debug "URLGetDomain = " + sTemp1\s

URLGetPath (tHTTP\sURL, @sTemp1)
Debug "URLGetPath = " + sTemp1\s

URLGetBasicAuth (tHTTP\sURL, @sTemp1, @sTemp2)
Debug "URLGetBasicAuth = " + sTemp1\s + ":" + sTemp2\s

Debug  ""

lRetVal = HTTPGetFromWeb (@tHTTP)

Debug  ""

Select lRetVal
    Case #PBL_OK    
        Debug "HTTPGetFromWeb() successful."
        Debug Str(tHTTP\lTotBytesRead) + " bytes read from Internet."
        
        Select tHTTP\lDestination
            Case #PBL_WRITE_TO_MEMORY
                 Debug Str(MemorySize(tHTTP\DestBuffer)) +  " bytes currently allocated in memory."
                 
            Case #PBL_WRITE_TO_FILE
                 Debug Str(tHTTP\lTotBytesRead) + " bytes written to " + tHTTP\sFullFileName 
        EndSelect

        
    Case #PBL_ERR_INTERNET_OPEN                
        Debug "Error initializing the WININET.DLL API."
        
    Case #PBL_ERR_INTERNET_CONNECT
        Debug "Error opening the session to the given site."
        
    Case #PBL_ERR_INTERNET_SET_PROXY
        Debug "Error setting the options for the proxy server."
        
    Case #PBL_ERR_INTERNET_HTTP_OPEN
        Debug "Error creating the HTTP request handle."
        
    Case #PBL_ERR_INTERNET_HTTP_SEND
        Debug "Error sending the HTTP request to the server."
        
    Case #PBL_ERR_INTERNET_HTTP_QUERY_STATUS
        Debug "Error retrieving the HTTP status code."
        
    Case #PBL_ERR_INTERNET_READ
        Debug "Error reading data from the opened session."
        
    Case #PBL_ERR_INTERNET_CLOSE
        Debug "Error closing the Internet handle."
    
    Case #PBL_ERR_INTERNET_BASIC_AUTH
        Debug "Error setting the options for basic authentication."
    
    Case #PBL_ERR_HTTP_STATUS                      
        Debug "HTTP status code = " + Str(tHTTP\lErrorCodeEx)

    Case #PBL_ERR_FILE_CREATION                
        Debug "Cannot create the file " + tHTTP\sFullFileName
        
    Case #PBL_ERR_FILE_IO                      
        Debug "Error writing to the file " + tHTTP\sFullFileName

    Case #PBL_ERR_INVALID_PARAMETERS
        Debug "Check procedure parameters."
                
    Case #PBL_ERR_OUT_OF_MEMORY                        
        Debug "Out of memory." 

    Case #PBL_ERR_ABORT_REQUESTED              
        Debug "Download aborted."                    
        
    Default
        Debug "Unexpected error = " + Str(lRetVal)
EndSelect

; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 190
; FirstLine = 80
; Folding = 5
; EnableThread
; CPU = 1