IncludeFile "HTTPGetFromWeb2.pb"

;******************************************************************************
; HTTPGetFromWeb() - MT Test
; November 4, 2007 by Luis
;******************************************************************************

Global Dim lHTTPRetVal.l (2)
Global Dim flgAbortRequested.l (2)

Procedure MyCallEnd (*tHTTP.T_PBL_HTTP_GET_FROM_WEB, lRetVal, lBytesReceived.l, lSize.l, lElapsedTime.l)
 Protected sText.s

 sText = *tHTTP\sFullFileName + " - "
  
 Select lRetVal

    Case #PBL_OK    
        sText + "HTTPGetFromWeb() successful (" + Str(*tHTTP\lTotBytesRead) + " bytes read)."       
        
    Case #PBL_ERR_INTERNET_OPEN                
        sText + "Error initializing the WININET.DLL API."
        
    Case #PBL_ERR_INTERNET_CONNECT
        sText + "Error opening the session to the given site."
        
    Case #PBL_ERR_INTERNET_SET_PROXY
        sText + "Error setting the option for the proxy server."
        
    Case #PBL_ERR_INTERNET_HTTP_OPEN
        sText + "Error creating the HTTP request handle."
        
    Case #PBL_ERR_INTERNET_HTTP_SEND
        sText + "Error sending the HTTP request to the server."
        
    Case #PBL_ERR_INTERNET_HTTP_QUERY_STATUS
        sText + "Error retrieving the HTTP status code."
        
    Case #PBL_ERR_INTERNET_READ
        sText + "Error reading data from the opened session."
        
    Case #PBL_ERR_INTERNET_CLOSE
        sText + "Error closing the Internet handle."
           
    Case #PBL_ERR_INTERNET_BASIC_AUTH
        sText + "Error setting the options for basic authentication."        
    
    Case #PBL_ERR_HTTP_STATUS                      
        sText + "HTTP status code = " + Str(*tHTTP\lErrorCodeEx)

    Case #PBL_ERR_FILE_CREATION                
        sText + "Cannot create the file " + *tHTTP\sFullFileName
        
    Case #PBL_ERR_FILE_IO                      
        sText + "Error writing to the file " + *tHTTP\sFullFileName

    Case #PBL_ERR_INVALID_PARAMETERS
        sText + "Check procedure parameters."
                
    Case #PBL_ERR_OUT_OF_MEMORY                        
        sText + "Out of memory." 
        
    Case #PBL_ERR_ABORT_REQUESTED              
        sText + "Download aborted."                            
               
    Default
        sText + "Unexpected error = " + Str(lHTTPRetVal(*tHTTP\lThreadID))
 EndSelect
 
 SetGadgetText(*tHTTP\lThreadID + 4, sText) 
EndProcedure

Procedure.l MyCallBack (*tHTTP.T_PBL_HTTP_GET_FROM_WEB, lBytesReceived.l, lSize.l, lElapsedTime.l)
 Protected sText.s
  
 sText = *tHTTP\sFullFileName + " ("  + Str(lBytesReceived) + "/"
 
 If lSize
    sText + Str(lSize) 
    SetGadgetState(*tHTTP\lThreadID + 1, (lBytesReceived * 1.0 / lSize) * 100)
 Else
   sText + "Unknown"
 EndIf
 
 sText + ")"

 If (lElapsedTime > 0)   
    sText + " Speed = " + Str (lBytesReceived / lElapsedTime / 1024) + " KB/Sec"
 EndIf
 
 SetGadgetText(*tHTTP\lThreadID + 4, sText)
 
 If flgAbortRequested (*tHTTP\lThreadID) 
    SetGadgetState(*tHTTP\lThreadID + 1, 0)
    SetGadgetText(*tHTTP\lThreadID + 4, "File " + Str(*tHTTP\lThreadID) + " aborted.")
    DisableGadget(*tHTTP\lThreadID + 7, #True)       
    ProcedureReturn #False
 Else
    ProcedureReturn #True 
 EndIf
  
EndProcedure

Procedure MT_HTTPGetFromWeb (*tHTTP.T_PBL_HTTP_GET_FROM_WEB)
    lHTTPRetVal(*tHTTP\lThreadID) = HTTPGetFromWeb (*tHTTP)
EndProcedure

Procedure WinMain()
 
 Protected Dim lThreadID.l (2)
 Protected Dim tHTTP.T_PBL_HTTP_GET_FROM_WEB (2)
 Protected lIndex.l, flgRunning.l, lEvent.l

 If OpenWindow(1, 10, 10, 570, 180, "HTTPGetFromWeb() 2.0 - MT Test",  #PB_Window_SystemMenu)
   

    ProgressBarGadget (1,  10, 30, 450,  20, 0, 100)
    ProgressBarGadget (2,  10, 80, 450,  20, 0, 100)
    ProgressBarGadget (3,  10, 130, 450,  20, 0, 100)              
    
    TextGadget (4,  10, 10, 450,  20, "File 1")
    TextGadget (5,  10, 60, 450,  20, "File 2") 
    TextGadget (6,  10, 110, 450,  20, "File 3") 
    
    ButtonGadget(7, 480, 30, 80, 20, "Abort")
    ButtonGadget(8, 480, 80, 80, 20, "Abort")
    ButtonGadget(9, 480, 130, 80, 20, "Abort")


    tHTTP(0)\sURL = "http://www.purebasic.com/download/PureBasic_Demo.exe"
    tHTTP(1)\sURL = "http://www.purebasic.com/download/purebasic-demo.tar.gz"
    tHTTP(2)\sURL = "http://www.purebasic.com/download/PureBasic-Demo.dmg"
            
    For lIndex = 0 To 2
        tHTTP(lIndex)\lThreadID = lIndex 
        
        tHTTP(lIndex)\lDestination = #PBL_WRITE_TO_FILE
        tHTTP(lIndex)\lChunkSize = 65536
        tHTTP(lIndex)\fpCallBack = @MyCallBack()
        tHTTP(lIndex)\fpCallEnd = @MyCallEnd()            
        tHTTP(lIndex)\sFullFileName = "c:\" + GetFilePart(tHTTP(lIndex)\sURL)
        
        ;tHTTP(lIndex)\sFullFileName = "c:\file" + Str(lIndex) + ".dat"            
        
        flgAbortRequested(lIndex) = #False
        
        lThreadID(lIndex) = CreateThread (@MT_HTTPGetFromWeb(), @tHTTP(lIndex))
    Next
               
    Repeat      
        lEvent = WindowEvent()                                      
        
        Select lEvent            
            Case #PB_Event_Gadget
                Select EventGadget()
                    Case 7,8,9
                        flgAbortRequested(EventGadget() - 7) = #True
                EndSelect
        EndSelect 
        
        Delay(0)          
                    
    Until lEvent = #PB_Event_CloseWindow

    ; abort the running downloads, if any
            
    For lIndex = 0 To 2
        flgAbortRequested(lIndex) = #True
    Next
 Else        
    End
 EndIf    

 ; wait for all threads to terminate
 
 Repeat 
    flgRunning = #False
    
    For lIndex = 0 To 2
        If IsThread (lThreadID(lIndex))
            flgRunning  = #True
        EndIf
    Next    
        
    WindowEvent()    
    Delay(0)    
    
 Until Not flgRunning 

EndProcedure 


WinMain()

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 171
; FirstLine = 10
; Folding = 5
; EnableThread
; CPU = 1