;/-------------------\
;| GameFixer Plugin  |
;| NetBlock          |
;|                   |
;| Version 0.02      |
;| Date: 27.06.2012  |
;| PureBasic 4.60    |
;|                   |
;| by Thorium        |
;\-------------------/

EnableExplicit

Import "GameFixer Core.lib"
  UninstallStdProcHook(HookId.i)
  InstallWin32ApiHook.i(DllName.s, ProcName.s, HookProcAddr.i)
EndImport

Global SocketHookId.i
Global WSAStartupHookId.i

ProcedureDLL DetachProcess(Instance.i)

  UninstallStdProcHook(SocketHookId)
  UninstallStdProcHook(WSAStartupHookId)

EndProcedure

Procedure.i SocketHook(af.i, type.i, protocol.i)
  
  ProcedureReturn #WSAENETDOWN
  
EndProcedure

Procedure.i WSAStartupHook(wVersionRequested.i, lpWSAData.i)
  
  ProcedureReturn #WSASYSNOTREADY
  
EndProcedure

ProcedureDLL.i Config(Config.s)
  
  SocketHookId = InstallWin32ApiHook("Ws2_32.dll", "socket", @SocketHook())
  If SocketHookId = #False
    ProcedureReturn #False
  EndIf
  
  WSAStartupHookId = InstallWin32ApiHook("Ws2_32.dll", "WSAStartup", @WSAStartupHook())
  If WSAStartupHookId = #False
    ProcedureReturn #False
  EndIf

  ProcedureReturn #True
  
EndProcedure

; IDE Options = PureBasic 4.60 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 4
; Folding = w
; EnableXP
; Executable = B:\GameFixer\Plugins\NetBlock.dll
; IncludeVersionInfo
; VersionField0 = 0,2,0,0
; VersionField1 = 0,2,0,0
; VersionField3 = NetBlock
; VersionField6 = Game Fixer Plugin
; VersionField9 = Janos David Ommert
; VersionField15 = VOS_NT_WINDOWS32
; VersionField16 = VFT_DLL