;/-------------------------\
;| DirectDraw Include      |
;|                         |
;| Date: 30.06.2012        |
;| PureBasic 4.60          |
;|                         |
;| by Thorium              |
;\-------------------------/

EnableExplicit

#DDENUM_ATTACHEDSECONDARYDEVICES = $00000001
#DDENUM_DETACHEDSECONDARYDEVICES = $00000002
#DDENUM_NONDISPLAYDEVICES = $00000004

#REGSTR_KEY_DDHW_DESCRIPTION = "Description"
#REGSTR_KEY_DDHW_DRIVERNAME = "DriverName"
#REGSTR_PATH_DDHW = "Hardware\DirectDrawDrivers"

#DD_ROP_SPACE = 256/32

#MAX_DDDEVICEID_STRING = 512

#DDGDI_GETHOSTIDENTIFIER = $00000001

;DIRECTDRAW PIXELFORMAT FLAGS
#DDPF_ALPHAPIXELS       = $00000001 ; The surface has alpha channel information in the pixel format.
#DDPF_ALPHA             = $00000002 ; The pixel format contains alpha only information.
#DDPF_FOURCC            = $00000004 ; The FourCC code is valid.
#DDPF_PALETTEINDEXED4   = $00000008 ; The surface is 4-bit color indexed.
#DDPF_PALETTEINDEXEDTO8 = $00000010 ; The surface is indexed into a palette which stores indices into the destination surface's 8-bit palette.
#DDPF_PALETTEINDEXED8   = $00000020 ; The surface is 8-bit color indexed.
#DDPF_RGB               = $00000040 ; The RGB data in the pixel format structure is valid.
#DDPF_COMPRESSED        = $00000080 ; The surface will accept pixel data in the format specified and compress it during the write.
#DDPF_RGBTOYUV          = $00000100 ; The surface will accept RGB data and translate it during the write to YUV data. The format of the data to be written will be contained in the pixel format structure. The DDPF_RGB flag will be set.
#DDPF_YUV               = $00000200 ; pixel format is YUV - YUV Data in pixel format struct is valid
#DDPF_ZBUFFER           = $00000400 ; pixel format is a z buffer only surface
#DDPF_PALETTEINDEXED1   = $00000800 ; The surface is 1-bit color indexed.
#DDPF_PALETTEINDEXED2   = $00001000 ; The surface is 2-bit color indexed.
#DDPF_ZPIXELS           = $00002000 ; The surface contains Z information in the pixels.
#DDPF_STENCILBUFFER     = $00004000 ; The surface contains stencil information along with Z.
#DDPF_ALPHAPREMULT      = $00008000 ; Premultiplied alpha format -- the color components have been premultiplied by the alpha component.
#DDPF_LUMINANCE         = $00020000 ; Luminance data in the pixel format is valid. Use this flag for luminance-only or luminance+alpha surfaces, the bit depth is then ddpf.dwLuminanceBitCount.
#DDPF_BUMPLUMINANCE     = $00040000 ; Luminance data in the pixel format is valid. Use this flag when hanging luminance off bumpmap surfaces, the bit mask for the luminance portion of the pixel is then ddpf.dwBumpLuminanceBitMask.
#DDPF_BUMPDUDV          = $00080000 ; Bump map dUdV data in the pixel format is valid.

#DDSCAPS2_RESERVED4 = $00000002
#DDSCAPS2_HARDWAREDEINTERLACE = $00000000
#DDSCAPS2_HINTDYNAMIC = $00000004
#DDSCAPS2_HINTSTATIC = $00000008
#DDSCAPS2_TEXTUREMANAGE = $00000010
#DDSCAPS2_RESERVED1 = $00000020
#DDSCAPS2_RESERVED2 = $00000040
#DDSCAPS2_OPAQUE = $00000080
#DDSCAPS2_HINTANTIALIASING = $00000100
#DDSCAPS2_CUBEMAP = $00000200
#DDSCAPS2_CUBEMAP_POSITIVEX = $00000400
#DDSCAPS2_CUBEMAP_NEGATIVEX = $00000800
#DDSCAPS2_CUBEMAP_POSITIVEY = $00001000
#DDSCAPS2_CUBEMAP_NEGATIVEY = $00002000
#DDSCAPS2_CUBEMAP_POSITIVEZ = $00004000
#DDSCAPS2_CUBEMAP_NEGATIVEZ = $00008000
#DDSCAPS2_CUBEMAP_ALLFACES = #DDSCAPS2_CUBEMAP_POSITIVEX | #DDSCAPS2_CUBEMAP_NEGATIVEX | #DDSCAPS2_CUBEMAP_POSITIVEY | #DDSCAPS2_CUBEMAP_NEGATIVEY | #DDSCAPS2_CUBEMAP_POSITIVEZ | #DDSCAPS2_CUBEMAP_NEGATIVEZ
#DDSCAPS2_MIPMAPSUBLEVEL = $00010000
#DDSCAPS2_D3DTEXTUREMANAGE = $00020000
#DDSCAPS2_DONOTPERSIST = $00040000
#DDSCAPS2_STEREOSURFACELEFT = $00080000
#DDSCAPS2_VOLUME = $00200000
#DDSCAPS2_NOTUSERLOCKABLE = $00400000
#DDSCAPS2_POINTS = $00800000
#DDSCAPS2_RTPATCHES = $01000000
#DDSCAPS2_NPATCHES = $02000000
#DDSCAPS2_RESERVED3 = $04000000
#DDSCAPS2_DISCARDBACKBUFFER = $10000000
#DDSCAPS2_ENABLEALPHACHANNEL = $20000000
#DDSCAPS2_EXTENDEDFORMATPRIMARY = $40000000
#DDSCAPS2_ADDITIONALPRIMARY = $80000000

#DDSCAPS3_MULTISAMPLE_MASK = $0000001F
#DDSCAPS3_MULTISAMPLE_QUALITY_MASK = $000000E0
#DDSCAPS3_MULTISAMPLE_QUALITY_SHIFT = 5
#DDSCAPS3_RESERVED1 = $00000100
#DDSCAPS3_RESERVED2 = $00000200
#DDSCAPS3_LIGHTWEIGHTMIPMAP = $00000400
#DDSCAPS3_AUTOGENMIPMAP = $00000800
#DDSCAPS3_DMAP = $00001000

#DDCAPS2_STEREO = $02000000
#DDCAPS2_SYSTONONLOCAL_AS_SYSTOLOCAL = $04000000
#DDCAPS2_RESERVED1 = $08000000
#DDCAPS2_CANMANAGERESOURCE = $10000000
#DDCAPS2_DYNAMICTEXTURES = $20000000
#DDCAPS2_CANAUTOGENMIPMAP = $40000000

#DDFXCAPS_BLTARITHSTRETCHY = $00000020
#DDFXCAPS_BLTARITHSTRETCHYN = $00000010
#DDFXCAPS_BLTMIRRORLEFTRIGHT = $00000040
#DDFXCAPS_BLTMIRRORUPDOWN = $00000080
#DDFXCAPS_BLTROTATION = $00000100
#DDFXCAPS_BLTROTATION90 = $00000200
#DDFXCAPS_BLTSHRINKX = $00000400
#DDFXCAPS_BLTSHRINKXN = $00000800
#DDFXCAPS_BLTSHRINKY = $00001000
#DDFXCAPS_BLTSHRINKYN = $00002000
#DDFXCAPS_BLTSTRETCHX = $00004000
#DDFXCAPS_BLTSTRETCHXN = $00008000
#DDFXCAPS_BLTSTRETCHY = $00010000
#DDFXCAPS_BLTSTRETCHYN = $00020000
#DDFXCAPS_OVERLAYARITHSTRETCHY = $00040000
#DDFXCAPS_OVERLAYARITHSTRETCHYN = $00000008
#DDFXCAPS_OVERLAYSHRINKX = $00080000
#DDFXCAPS_OVERLAYSHRINKXN = $00100000
#DDFXCAPS_OVERLAYSHRINKY = $00200000
#DDFXCAPS_OVERLAYSHRINKYN = $00400000
#DDFXCAPS_OVERLAYSTRETCHX = $00800000
#DDFXCAPS_OVERLAYSTRETCHXN = $01000000
#DDFXCAPS_OVERLAYSTRETCHY = $02000000
#DDFXCAPS_OVERLAYSTRETCHYN = $04000000
#DDFXCAPS_OVERLAYMIRRORLEFTRIGHT = $08000000
#DDFXCAPS_OVERLAYMIRRORUPDOWN = $10000000
#DDFXCAPS_OVERLAYDEINTERLACE = $20000000
#DDFXCAPS_BLTALPHA = $00000001
#DDFXCAPS_BLTFILTER = #DDFXCAPS_BLTARITHSTRETCHY
#DDFXCAPS_OVERLAYALPHA = $00000004
#DDFXCAPS_OVERLAYFILTER = #DDFXCAPS_OVERLAYARITHSTRETCHY

#DDSVCAPS_STEREOSEQUENTIAL = $00000010

#DDSPD_IUNKNOWNPOINTER = $00000001
#DDSPD_VOLATILE = $00000002

#DDEDM_STANDARDVGAMODES = $00000002

#DDBLTFAST_NOCOLORKEY = $00000000
#DDBLTFAST_SRCCOLORKEY = $00000001
#DDBLTFAST_DESTCOLORKEY = $00000002
#DDBLTFAST_WAIT = $00000010
#DDBLTFAST_DONOTWAIT = $00000020

#DDFLIP_WAIT = $00000001
#DDFLIP_EVEN = $00000002
#DDFLIP_ODD = $00000004
#DDFLIP_NOVSYNC = $00000008
#DDFLIP_INTERVAL2 = $02000000
#DDFLIP_INTERVAL3 = $03000000
#DDFLIP_INTERVAL4 = $04000000
#DDFLIP_STEREO = $00000010
#DDFLIP_DONOTWAIT = $00000020

#DDLOCK_SURFACEMEMORYPTR = $00000000
#DDLOCK_WAIT = $00000001
#DDLOCK_EVENT = $00000002
#DDLOCK_READONLY = $00000010
#DDLOCK_WRITEONLY = $00000020
#DDLOCK_NOSYSLOCK = $00000800
#DDLOCK_NOOVERWRITE = $00001000
#DDLOCK_DISCARDCONTENTS = $00002000
#DDLOCK_OKTOSWAP = $00002000
#DDLOCK_DONOTWAIT = $00004000
#DDLOCK_HASVOLUMETEXTUREBOXRECT = $00008000
#DDLOCK_NODIRTYUPDATE = $00010000

#DDSGR_CALIBRATE = $00000001

#DDSMT_ISTESTREQUIRED = $00000001

#DDEM_MODEPASSED = $00000001
#DDEM_MODEFAILED = $00000002

#DD_OK = #S_OK
#DD_FALSE = #S_FALSE

#DDENUMRET_CANCEL = 0
#DDENUMRET_OK = 1

#DDERR_ALREADYINITIALIZED = $10000000+( 5)
#DDERR_CANNOTATTACHSURFACE = $10000000+( 10)
#DDERR_CANNOTDETACHSURFACE = $10000000+( 20)
#DDERR_CURRENTLYNOTAVAIL = $10000000+( 40)
#DDERR_EXCEPTION = $10000000+( 55)
#DDERR_GENERIC = #E_FAIL
#DDERR_HEIGHTALIGN = $10000000+( 90)
#DDERR_INCOMPATIBLEPRIMARY = $10000000+( 95)
#DDERR_INVALIDCAPS = $10000000+( 100)
#DDERR_INVALIDCLIPLIST = $10000000+( 110)
#DDERR_INVALIDMODE = $10000000+( 120)
#DDERR_INVALIDOBJECT = $10000000+( 130)
#DDERR_INVALIDPARAMS = #E_INVALIDARG
#DDERR_INVALIDPIXELFORMAT = $10000000+( 145)
#DDERR_INVALIDRECT = $10000000+( 150)
#DDERR_LOCKEDSURFACES = $10000000+( 160)
#DDERR_NO3D = $10000000+( 170)
#DDERR_NOALPHAHW = $10000000+( 180)
#DDERR_NOSTEREOHARDWARE = $10000000+( 181)
#DDERR_NOSURFACELEFT = $10000000+( 182)
#DDERR_NOCLIPLIST = $10000000+( 205)
#DDERR_NOCOLORCONVHW = $10000000+( 210)
#DDERR_NOCOOPERATIVELEVELSET = $10000000+( 212)
#DDERR_NOCOLORKEY = $10000000+( 215)
#DDERR_NOCOLORKEYHW = $10000000+( 220)
#DDERR_NODIRECTDRAWSUPPORT = $10000000+( 222)
#DDERR_NOEXCLUSIVEMODE = $10000000+( 225)
#DDERR_NOFLIPHW = $10000000+( 230)
#DDERR_NOGDI = $10000000+( 240)
#DDERR_NOMIRRORHW = $10000000+( 250)
#DDERR_NOTFOUND = $10000000+( 255)
#DDERR_NOOVERLAYHW = $10000000+( 260)
#DDERR_OVERLAPPINGRECTS = $10000000+( 270)
#DDERR_NORASTEROPHW = $10000000+( 280)
#DDERR_NOROTATIONHW = $10000000+( 290)
#DDERR_NOSTRETCHHW = $10000000+( 310)
#DDERR_NOT4BITCOLOR = $10000000+( 316)
#DDERR_NOT4BITCOLORINDEX = $10000000+( 317)
#DDERR_NOT8BITCOLOR = $10000000+( 320)
#DDERR_NOTEXTUREHW = $10000000+( 330)
#DDERR_NOVSYNCHW = $10000000+( 335)
#DDERR_NOZBUFFERHW = $10000000+( 340)
#DDERR_NOZOVERLAYHW = $10000000+( 350)
#DDERR_OUTOFCAPS = $10000000+( 360)
#DDERR_OUTOFMEMORY = #E_OUTOFMEMORY
#DDERR_OUTOFVIDEOMEMORY = $10000000+( 380)
#DDERR_OVERLAYCANTCLIP = $10000000+( 382)
#DDERR_OVERLAYCOLORKEYONLYONEACTIVE = $10000000+( 384)
#DDERR_PALETTEBUSY = $10000000+( 387)
#DDERR_COLORKEYNOTSET = $10000000+( 400)
#DDERR_SURFACEALREADYATTACHED = $10000000+( 410)
#DDERR_SURFACEALREADYDEPENDENT = $10000000+( 420)
#DDERR_SURFACEBUSY = $10000000+( 430)
#DDERR_CANTLOCKSURFACE = $10000000+( 435)
#DDERR_SURFACEISOBSCURED = $10000000+( 440)
#DDERR_SURFACELOST = $10000000+( 450)
#DDERR_SURFACENOTATTACHED = $10000000+( 460)
#DDERR_TOOBIGHEIGHT = $10000000+( 470)
#DDERR_TOOBIGSIZE = $10000000+( 480)
#DDERR_TOOBIGWIDTH = $10000000+( 490)
#DDERR_UNSUPPORTED = #E_NOTIMPL
#DDERR_UNSUPPORTEDFORMAT = $10000000+( 510)
#DDERR_UNSUPPORTEDMASK = $10000000+( 520)
#DDERR_INVALIDSTREAM = $10000000+( 521)
#DDERR_VERTICALBLANKINPROGRESS = $10000000+( 537)
#DDERR_WASSTILLDRAWING = $10000000+( 540)
#DDERR_DDSCAPSCOMPLEXREQUIRED = $10000000+( 542)
#DDERR_XALIGN = $10000000+( 560)
#DDERR_INVALIDDIRECTDRAWGUID = $10000000+( 561)
#DDERR_DIRECTDRAWALREADYCREATED = $10000000+( 562)
#DDERR_NODIRECTDRAWHW = $10000000+( 563)
#DDERR_PRIMARYSURFACEALREADYEXISTS = $10000000+( 564)
#DDERR_NOEMULATION = $10000000+( 565)
#DDERR_REGIONTOOSMALL = $10000000+( 566)
#DDERR_CLIPPERISUSINGHWND = $10000000+( 567)
#DDERR_NOCLIPPERATTACHED = $10000000+( 568)
#DDERR_NOHWND = $10000000+( 569)
#DDERR_HWNDSUBCLASSED = $10000000+( 570)
#DDERR_HWNDALREADYSET = $10000000+( 571)
#DDERR_NOPALETTEATTACHED = $10000000+( 572)
#DDERR_NOPALETTEHW = $10000000+( 573)
#DDERR_BLTFASTCANTCLIP = $10000000+( 574)
#DDERR_NOBLTHW = $10000000+( 575)
#DDERR_NODDROPSHW = $10000000+( 576)
#DDERR_OVERLAYNOTVISIBLE = $10000000+( 577)
#DDERR_NOOVERLAYDEST = $10000000+( 578)
#DDERR_INVALIDPOSITION = $10000000+( 579)
#DDERR_NOTAOVERLAYSURFACE = $10000000+( 580)
#DDERR_EXCLUSIVEMODEALREADYSET = $10000000+( 581)
#DDERR_NOTFLIPPABLE = $10000000+( 582)
#DDERR_CANTDUPLICATE = $10000000+( 583)
#DDERR_NOTLOCKED = $10000000+( 584)
#DDERR_CANTCREATEDC = $10000000+( 585)
#DDERR_NODC = $10000000+( 586)
#DDERR_WRONGMODE = $10000000+( 587)
#DDERR_IMPLICITLYCREATED = $10000000+( 588)
#DDERR_NOTPALETTIZED = $10000000+( 589)
#DDERR_UNSUPPORTEDMODE = $10000000+( 590)
#DDERR_NOMIPMAPHW = $10000000+( 591)
#DDERR_INVALIDSURFACETYPE = $10000000+( 592)
#DDERR_NOOPTIMIZEHW = $10000000+( 600)
#DDERR_NOTLOADED = $10000000+( 601)
#DDERR_NOFOCUSWINDOW = $10000000+( 602)
#DDERR_NOTONMIPMAPSUBLEVEL = $10000000+( 603)
#DDERR_DCALREADYCREATED = $10000000+( 620)
#DDERR_NONONLOCALVIDMEM = $10000000+( 630)
#DDERR_CANTPAGELOCK = $10000000+( 640)
#DDERR_CANTPAGEUNLOCK = $10000000+( 660)
#DDERR_NOTPAGELOCKED = $10000000+( 680)
#DDERR_MOREDATA = $10000000+( 690)
#DDERR_EXPIRED = $10000000+( 691)
#DDERR_TESTFINISHED = $10000000+( 692)
#DDERR_NEWMODE = $10000000+( 693)
#DDERR_D3DNOTINITIALIZED = $10000000+( 694)
#DDERR_VIDEONOTACTIVE = $10000000+( 695)
#DDERR_NOMONITORINFORMATION = $10000000+( 696)
#DDERR_NODRIVERSUPPORT = $10000000+( 697)
#DDERR_DEVICEDOESNTOWNSURFACE = $10000000+( 699)
#DDERR_NOTINITIALIZED = #CO_E_NOTINITIALIZED

Structure DDSCAPS
  dwCaps.l
EndStructure

Structure DDOSCAPS
  dwCaps.l
EndStructure

Structure DDSCAPSEX
  dwCaps2.l
  dwCaps3.l
  StructureUnion
    dwCaps4.l
    dwVolumeDepth.l
  EndStructureUnion
EndStructure

Structure DDSCAPS2
  dwCaps.l
  dwCaps2.l
  dwCaps3.l
  StructureUnion
    dwCaps4.l
    dwVolumeDepth.l
  EndStructureUnion
EndStructure

Structure DDCAPS_DX1
  dwSize.l                         ; size of the DDDRIVERCAPS Structure
  dwCaps.l                         ; driver specific capabilities
  dwCaps2.l                        ; more driver specific capabilites
  dwCKeyCaps.l                     ; color key capabilities of the surface
  dwFXCaps.l                       ; driver specific stretching And effects capabilites
  dwFXAlphaCaps.l                  ; alpha driver specific capabilities
  dwPalCaps.l                      ; palette capabilities
  dwSVCaps.l                       ; stereo vision capabilities
  dwAlphaBltConstBitDepths.l       ; DDBD_2,4,8
  dwAlphaBltPixelBitDepths.l       ; DDBD_1,2,4,8
  dwAlphaBltSurfaceBitDepths.l     ; DDBD_1,2,4,8
  dwAlphaOverlayConstBitDepths.l   ; DDBD_2,4,8
  dwAlphaOverlayPixelBitDepths.l   ; DDBD_1,2,4,8
  dwAlphaOverlaySurfaceBitDepths.l ; DDBD_1,2,4,8
  dwZBufferBitDepths.l             ; DDBD_8,16,24,32
  dwVidMemTotal.l                  ; total amount of video memory
  dwVidMemFree.l                   ; amount of free video memory
  dwMaxVisibleOverlays.l           ; maximum number of visible overlays
  dwCurrVisibleOverlays.l          ; current number of visible overlays
  dwNumFourCCCodes.l               ; number of four cc codes
  dwAlignBoundarySrc.l             ; source rectangle alignment
  dwAlignSizeSrc.l                 ; source rectangle byte size
  dwAlignBoundaryDest.l            ; dest rectangle alignment
  dwAlignSizeDest.l                ; dest rectangle byte size
  dwAlignStrideAlign.l             ; stride alignment
  dwRops.l[#DD_ROP_SPACE]          ; ROPS supported
  ddsCaps.DDSCAPS                  ; DDSCAPS structure has all the general capabilities
  dwMinOverlayStretch.l            ; minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwMaxOverlayStretch.l            ; maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwMinLiveVideoStretch.l          ; OBSOLETE! This field remains for compatability reasons only
  dwMaxLiveVideoStretch.l          ; OBSOLETE! This field remains for compatability reasons only
  dwMinHwCodecStretch.l            ; OBSOLETE! This field remains for compatability reasons only
  dwMaxHwCodecStretch.l            ; OBSOLETE! This field remains for compatability reasons only
  dwReserved1.l                    ; reserved
  dwReserved2.l                    ; reserved
  dwReserved3.l                    ; reserved
EndStructure

Structure DDCAPS_DX3
  dwSize.l                         ; size of the DDDRIVERCAPS Structure
  dwCaps.l                         ; driver specific capabilities
  dwCaps2.l                        ; more driver specific capabilites
  dwCKeyCaps.l                     ; color key capabilities of the surface
  dwFXCaps.l                       ; driver specific stretching And effects capabilites
  dwFXAlphaCaps.l                  ; alpha driver specific capabilities
  dwPalCaps.l                      ; palette capabilities
  dwSVCaps.l                       ; stereo vision capabilities
  dwAlphaBltConstBitDepths.l       ; DDBD_2,4,8
  dwAlphaBltPixelBitDepths.l       ; DDBD_1,2,4,8
  dwAlphaBltSurfaceBitDepths.l     ; DDBD_1,2,4,8
  dwAlphaOverlayConstBitDepths.l   ; DDBD_2,4,8
  dwAlphaOverlayPixelBitDepths.l   ; DDBD_1,2,4,8
  dwAlphaOverlaySurfaceBitDepths.l ; DDBD_1,2,4,8
  dwZBufferBitDepths.l             ; DDBD_8,16,24,32
  dwVidMemTotal.l                  ; total amount of video memory
  dwVidMemFree.l                   ; amount of free video memory
  dwMaxVisibleOverlays.l           ; maximum number of visible overlays
  dwCurrVisibleOverlays.l          ; current number of visible overlays
  dwNumFourCCCodes.l               ; number of four cc codes
  dwAlignBoundarySrc.l             ; source rectangle alignment
  dwAlignSizeSrc.l                 ; source rectangle byte size
  dwAlignBoundaryDest.l            ; dest rectangle alignment
  dwAlignSizeDest.l                ; dest rectangle byte size
  dwAlignStrideAlign.l             ; stride alignment
  dwRops.l[#DD_ROP_SPACE]          ; ROPS supported
  ddsCaps.DDSCAPS                  ; DDSCAPS structure has all the general capabilities
  dwMinOverlayStretch.l            ; minimum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwMaxOverlayStretch.l            ; maximum overlay stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwMinLiveVideoStretch.l          ; minimum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwMaxLiveVideoStretch.l          ; maximum live video stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwMinHwCodecStretch.l            ; minimum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwMaxHwCodecStretch.l            ; maximum hardware codec stretch factor multiplied by 1000, eg 1000 == 1.0, 1300 == 1.3
  dwReserved1.l                    ; reserved
  dwReserved2.l                    ; reserved
  dwReserved3.l                    ; reserved
  dwSVBCaps.l                      ; driver specific capabilities for System->Vmem blts
  dwSVBCKeyCaps.l                  ; driver color key capabilities for System->Vmem blts
  dwSVBFXCaps.l                    ; driver FX capabilities for System->Vmem blts
  dwSVBRops.l[#DD_ROP_SPACE]       ; ROPS supported for System->Vmem blts
  dwVSBCaps.l                      ; driver specific capabilities for Vmem->System blts
  dwVSBCKeyCaps.l                  ; driver color key capabilities for Vmem->System blts
  dwVSBFXCaps.l                    ; driver FX capabilities for Vmem->System blts
  dwVSBRops.l[#DD_ROP_SPACE]       ; ROPS supported for Vmem->System blts
  dwSSBCaps.l                      ; driver specific capabilities for System->System blts
  dwSSBCKeyCaps.l                  ; driver color key capabilities for System->System blts
  dwSSBFXCaps.l                    ; driver FX capabilities for System->System blts
  dwSSBRops.l[#DD_ROP_SPACE]       ; ROPS supported for System->System blts
  dwReserved4.l                    ; reserved
  dwReserved5.l                    ; reserved
  dwReserved6.l                    ; reserved
EndStructure

Structure MultiSampleCapsStruc
  wFlipMSTypes.w                   ; Multisample methods supported via flip for this D3DFORMAT
  wBltMSTypes.w                    ; Multisample methods supported via blt for this D3DFORMAT
EndStructure

Structure DDPIXELFORMAT
  dwSize.l                         ; size of structure
  dwFlags.l                        ; pixel format flags
  dwFourCC.l                       ; (FOURCC code)
  StructureUnion
    dwRGBBitCount.l                ; how many bits per pixel
    dwYUVBitCount.l                ; how many bits per pixel
    dwZBufferBitDepth.l            ; how many total bits/pixel in z buffer (including any stencil bits)
    dwAlphaBitDepth.l              ; how many bits for alpha channels
    dwLuminanceBitCount.l          ; how many bits per pixel
    dwBumpBitCount.l               ; how many bits per "buxel", total
    dwPrivateFormatBitCount.l      ; Bits per pixel of private driver formats. Only valid in texture
  EndStructureUnion
  StructureUnion
    dwRBitMask.l                   ; mask for red bit
    dwYBitMask.l                   ; mask for Y bits
    dwStencilBitDepth.l            ; how many stencil bits (note: dwZBufferBitDepth-dwStencilBitDepth is total Z-only bits)
    dwLuminanceBitMask.l           ; mask for luminance bits
    dwBumpDuBitMask.l              ; mask for bump map U delta bits
    dwOperations.l                 ; DDPF_D3DFORMAT Operations
  EndStructureUnion
  StructureUnion
    dwGBitMask.l                   ; mask for green bits
    dwUBitMask.l                   ; mask for U bits
    dwZBitMask.l                   ; mask for Z bits
    dwBumpDvBitMask.l              ; mask for bump map V delta bits
    MultiSampleCaps.MultiSampleCapsStruc
  EndStructureUnion
  StructureUnion
    dwBBitMask.l                   ; mask for blue bits
    dwVBitMask.l                   ; mask for V bits
    dwStencilBitMask.l             ; mask for stencil bits
    dwBumpLuminanceBitMask.l       ; mask for luminance in bump map
  EndStructureUnion
  StructureUnion
    dwRGBAlphaBitMask.l            ; mask for alpha channel
    dwYUVAlphaBitMask.l            ; mask for alpha channel
    dwLuminanceAlphaBitMask.l      ; mask for alpha channel
    dwRGBZBitMask.l                ; mask for Z channel
    dwYUVZBitMask.l                ; mask for Z channel
  EndStructureUnion
EndStructure

Structure DDCOLORKEY
  dwColorSpaceLowValue.l           
  dwColorSpaceHighValue.l
EndStructure

Structure DDSURFACEDESC
  dwSize.l                         ; size of the DDSURFACEDESC structure
  dwFlags.l                        ; determines what fields are valid
  dwHeight.l                       ; height of surface to be created
  dwWidth.l                        ; width of input surface
  StructureUnion
    lPitch.l                       ; distance to start of next line (return value only)
    dwLinearSize.l                 ; formless late-allocated optimized surface size
  EndStructureUnion
  dwBackBufferCount.l              ; number of back buffers requested
  StructureUnion
    dwMipMapCount.l                ; number of mip-map levels requested
    dwZBufferBitDepth.l            ; depth of Z buffer requested
    dwRefreshRate.l                ; refresh rate (used when display mode is described)
  EndStructureUnion
  dwAlphaBitDepth.l                ; depth of alpha buffer requested
  dwReserved.l                     ; reserved
  *lpSurface                       ; pointer to the associated surface memory
  ddckCKDestOverlay.DDCOLORKEY     ; color key for destination overlay use
  ddckCKDestBlt.DDCOLORKEY         ; color key for destination blt use
  ddckCKSrcOverlay.DDCOLORKEY      ; color key for source overlay use
  ddckCKSrcBlt.DDCOLORKEY          ; color key for source blt use
  ddpfPixelFormat.DDPIXELFORMAT    ; pixel format description of the surface
  ddsCaps.DDSCAPS                  ; direct draw surface capabilities
EndStructure

Structure DDSURFACEDESC2
  dwSize.l                         ; size of the DDSURFACEDESC2 structure
  dwFlags.l                        ; determines what fields are valid
  dwHeight.l                       ; height of surface to be created
  dwWidth.l                        ; width of input surface
  StructureUnion
    lPitch.l                       ; distance to start of next line (return value only)
    dwLinearSize.l                 ; formless late-allocated optimized surface size
  EndStructureUnion
  StructureUnion
    dwBackBufferCount.l            ; number of back buffers requested
    dwDepth.l                      ; the depth if this is a volume texture 
  EndStructureUnion
  StructureUnion
    dwMipMapCount.l                ; number of mip-map levels requestde
    dwRefreshRate.l                ; refresh rate (used when display mode is described)
    dwSrcVBHandle.l                ; the source used in VB::Optimize
  EndStructureUnion
  dwAlphaBitDepth.l                ; depth of alpha buffer requested
  dwReserved.l                     ; reserved
  *lpSurface                       ; pointer to the associated surface memory
  StructureUnion
    ddckCKDestOverlay.DDCOLORKEY   ; color key for destination overlay use
    dwEmptyFaceColor.l             ; Physical color for empty cubemap faces
  EndStructureUnion
  ddckCKDestBlt.DDCOLORKEY         ; color key for destination blt use
  ddckCKSrcOverlay.DDCOLORKEY      ; color key for source overlay use
  ddckCKSrcBlt.DDCOLORKEY          ; color key for source blt use
  StructureUnion
    ddpfPixelFormat.DDPIXELFORMAT  ; pixel format description of the surface
    dwFVF.l                        ; vertex format description of vertex buffers
  EndStructureUnion
  ddsCaps.DDSCAPS2                 ; direct draw surface capabilities
  dwTextureStage.l                 ; stage in multitexture cascade
EndStructure

DataSection
  
  CLSID_DirectDraw:
  Data.l $D7B70EE0
  Data.w $4340, $11CF
  Data.b $B0, $63, $00, $20, $AF, $C2, $CD, $35

  CLSID_DirectDraw7:
  Data.l $3C305196
  Data.w $50DB, $11D3
  Data.b $9C, $FE, $00, $C0, $4F, $D9, $30, $C5
  
  CLSID_DirectDrawClipper:
  Data.l $593817A0
  Data.w $7DB3, $11CF
  Data.b $A2, $DE, $00, $AA, $00, $B9, $33, $56
  
  IID_IDirectDraw:
  Data.l $6C14DB80
  Data.w $A733, $11CE
  Data.b $A5, $21, $00, $20, $AF, $0B, $E5, $60
  
  IID_IDirectDraw2:
  Data.l $B3A6F3E0
  Data.w $2B43, $11CF
  Data.b $A2, $DE, $00, $AA, $00, $B9, $33, $56
  
  IID_IDirectDraw4:
  Data.l $9C59509A
  Data.w $39BD, $11D1
  Data.b $8C, $4A, $00, $C0, $4F, $D9, $30, $C5
  
  IID_IDirectDraw7:
  Data.l $15E65EC0
  Data.w $3B9C, $11D2
  Data.b $B9, $2F, $00, $60, $97, $97, $EA, $5B
  
  IID_IDirectDrawSurface:
  Data.l $6C14DB81
  Data.w $A733, $11CE
  Data.b $A5, $21, $00, $20, $AF, $0B, $E5, $60
  
  IID_IDirectDrawSurface2:
  Data.l $57805885
  Data.w $6EEC, $11CF
  Data.b $94, $41, $A8, $23, $03, $C1, $0E, $27
  
  IID_IDirectDrawSurface3:
  Data.l $DA044E00
  Data.w $69B2, $11D0
  Data.b $A1, $D5, $00, $AA, $00, $B8, $DF, $BB
  
  IID_IDirectDrawSurface4:
  Data.l $0B2B8630
  Data.w $AD35, $11D0
  Data.b $8E, $A6, $00, $60, $97, $97, $EA, $5B
  
  IID_IDirectDrawSurface7:
  Data.l $06675A80
  Data.w $3B9B, $11D2
  Data.b $B9, $2F, $00, $60, $97, $97, $EA, $5B
  
  IID_IDirectDrawPalette:
  Data.l $6C14DB84
  Data.w $A733, $11CE
  Data.b $A5, $21, $00, $20, $AF, $0B, $E5, $60
  
  IID_IDirectDrawClipper:
  Data.l $6C14DB85
  Data.w $A733, $11CE
  Data.b $A5, $21, $00, $20, $AF, $0B, $E5, $60
  
  IID_IDirectDrawColorControl:
  Data.l $4B9F0EE0
  Data.w $0D7E, $11D0
  Data.b $9B, $06, $00, $A0, $C9, $03, $A3, $B8
  
  IID_IDirectDrawGammaControl:
  Data.l $69C11C3E
  Data.w $B46B, $11D1
  Data.b $AD, $7A, $00, $C0, $4F, $C2, $9B, $4E
  
EndDataSection

; IDE Options = PureBasic 4.60 (Windows - x86)
; EnableXP